Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mortbay.servlet
Class ThrottlingFilter

    java.lang.Object
      org.mortbay.servlet.ThrottlingFilter

All Implemented Interfaces:
  Filter

    public class ThrottlingFilter

extends Object
implements Filter

This filter protects a web application from having to handle an unmanageable load.

For servers where there is 1 application with standardized resource restrictions, then this affect can be easily controlled by limiting the size of the `server thread pool`, however where there are multiple applications, or a single application has different resource requirements for different URLs, then this filter can assist in managing the number of requests being services at any point in time.

The filter has 3 configurable values, which may be set as init parameters:

1. `maximum` determines the maxmimum number of requests that may be on the filter chain at any point in time. (See below for a more detailed explanation)
2. `block` determines how long (in milliseconds) a request will be queued before it is rejected. Set this to -1 to block indefinately.
3. `queue` determines how many requests can be queued simultaneously - any additional requests will be rejected. Set this to 0 to turn off queueing.

Request Counting: The filter counts how many requests are currently being services by the rest of the filter chain (including any servlets that may be configured to handle the request). Request counting is per instance of the filter. There is no syncronization between virtual machines, and the request count is not shared between multiple instances of the filter. Thus a web.xml file such as

      <filter><filter-name>throttle1</filter-name>
              <filter-class>org.adjective.spiral.filter.ThrottlingFilter</filter-class>
      <filter><filter-name>throttle2</filter-name>
              <filter-class>org.adjective.spiral.filter.ThrottlingFilter</filter-class>

creates 2 separate filters with individual request counts.

Queueing: When the number of active requests exceed the `maximum` requests will be queued. This queue regulates the flow of connections. Once the number of requests on the queue reached the `queue` threshold, then any new requests will be rejected. Requests are queued for a maximum of `block` milliseconds - is no capacity is made available in this time then the request will be rejected. The oldest pending request is removed from the queue and processed as soon as the number of pending requests falls below the `maximum` value (i.e. when a request is completed)

Rejection: Requests are rejected when the number of requests in progress has reached maximum and either the queue is full; or a request has been queued for more than `block` milliseconds. The rejection is performed by calling the method `rejectRequest(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)`. By default this method sends the HTTP status code `503`, but this may be over-ridden in derived classes.

This filter works best with the `SelectChannelConnector`, as `RetryRequest` based `Continuation`s can be used to free the thread and other resources associated with the queued requests.

Author:
  - Tim Vernum

Constructor Summary
`ThrottlingFilter()`

Method Summary
`void` | `destroy()` Called by the web container to indicate to a filter that it is being taken out of service.
`void` | `doFilter(HttpServletRequest request, HttpServletResponse response, FilterChain chain)`
`void` | `doFilter(ServletRequest request, ServletResponse response, FilterChain chain)` The `doFilter` method of the Filter is called by the container each time a request/response pair is passed through the chain due to a client request for a resource at the end of the chain.
`void` | `init(FilterConfig filterConfig)` Called by the web container to indicate to a filter that it is being placed into service.
`protected void` | `rejectRequest(HttpServletRequest request, HttpServletResponse response)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ThrottlingFilter

    public ThrottlingFilter()

Method Detail

### init

    public void init(FilterConfig filterConfig)
              throws ServletException

  Description copied from interface: `Filter`
  Called by the web container to indicate to a filter that it is being placed into service. The servlet container calls the init method exactly once after instantiating the filter. The init method must complete successfully before the filter is asked to do any filtering work.
  The web container cannot place the filter into service if the init method either
  1.Throws a ServletException
  2.Does not return within a time period defined by the web container

  Specified by:
    `init` in interface `Filter`
  Throws:
    `ServletException`

### doFilter

    public void doFilter(ServletRequest request,
                         ServletResponse response,
                         FilterChain chain)
                  throws IOException,
                         ServletException

  Description copied from interface: `Filter`
  The `doFilter` method of the Filter is called by the container each time a request/response pair is passed through the chain due to a client request for a resource at the end of the chain. The FilterChain passed in to this method allows the Filter to pass on the request and response to the next entity in the chain.

  A typical implementation of this method would follow the following pattern:-
  1. Examine the request
  2. Optionally wrap the request object with a custom implementation to filter content or headers for input filtering
  3. Optionally wrap the response object with a custom implementation to filter content or headers for output filtering
  4. a) Either invoke the next entity in the chain using the FilterChain object (`chain.doFilter()`),
  4. b) or not pass on the request/response pair to the next entity in the filter chain to block the request processing
  5. Directly set headers on the response after invocation of the next entity in the filter chain.

  Specified by:
    `doFilter` in interface `Filter`
  Throws:
    `IOException`
    `ServletException`

### doFilter

    public void doFilter(HttpServletRequest request,
                         HttpServletResponse response,
                         FilterChain chain)
                  throws IOException,
                         ServletException

  Throws:
    `IOException`
    `ServletException`

### rejectRequest

    protected void rejectRequest(HttpServletRequest request,
                                 HttpServletResponse response)
                          throws IOException

  Throws:
    `IOException`

### destroy

    public void destroy()

  Description copied from interface: `Filter`
  Called by the web container to indicate to a filter that it is being taken out of service. This method is only called once all threads within the filter's doFilter method have exited or after a timeout period has passed. After the web container calls this method, it will not call the doFilter method again on this instance of the filter.
  This method gives the filter an opportunity to clean up any resources that are being held (for example, memory, file handles, threads) and make sure that any persistent state is synchronized with the filter's current state in memory.

  Specified by:
    `destroy` in interface `Filter`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2007 Mort Bay Consulting. All Rights Reserved.